source("Q3.r")
source("prb3.r")

noRun=18
#input variables noF, study.ind
cat("noF= ")
noF=as.integer(readline())


assign("noRun", 18, envir=.GlobalEnv)
assign("noLev", 3, envir=.GlobalEnv)
NM=2 #noLev-2
assign("myArray", array(NA, c(noRun,noF,NM)), envir=.GlobalEnv)


cat("p1= ")
p1=readline()
cat("p2= ")
p2=readline()
cat("p3= ")
p3=readline()

pp=as.numeric(c(p1, p2, p3))


prmat=pr.mat(pp, noF, noRun)

pr.adj.c=pr.adj(prmat, noRun)
pradj=pr.adj.c$pradj
adj=pr.adj.c$adj
print(adj)

plot.hist(prmat, noF, noRun)


ind=matrix(c(0,0,0,1,0,0, 1,1,0, 2,0,0,2,1,0, 2,0,1,2,1,1,2,2,0,3,0,1,3,1,1,3,0,2,4,0,2), byrow=T, ncol=3)
xi.mat=c()
del.mat=c()
for (i in 1:dim(ind)[1]){
    abc=ind[i,]
    ret=adj.xi(abc, adj, pp, noF, noRun)
   ret2=mod.delta(abc, noF)
    xi=c(abc, ret)
    del=c(abc, ret2)
    xi.mat=rbind(xi.mat , xi)
    del.mat=rbind(del.mat, del)
}

print(del.mat)
print(xi.mat)



infile=paste("Col_F",noF,"R18.out", sep="")

all.design=matrix(scan(infile), byrow=T, ncol=noRun)
sz=dim(all.design)[1]/noF

cat("number of isomorphic designs : ", sz, " \n")

repeat {
  cat("study design= ")
  study.ind=as.integer(readline())

  if (study.ind==0) break 
 
#for (study.ind in c(1:sz)){
   Design=t(all.design[(noF*(study.ind-1)+1):(noF*study.ind),])

   myArray[,,1]=Design-2
   myArray[,,2] = sqrt(1/2)*(3 * myArray[,,1] ^2 - 2)
   myArray[,,1] = sqrt(3/2)*myArray[,,1]
   worList=c()
   resList=c()

   for(TC in 1:noF) {
      word=matrix.choose.count(NM, noF, TC)
      resList = append(resList, list(word))
      worList = rbind(worList, word)
   }
  

   ind.A=unlist(apply(worList[,c(1:NM)], 1, sum))
   ind.B=unlist(apply(worList[,c(1:NM)], 1, total.effect, NM))
   word.A=unlist(lapply(c(1:noF), word.sum, ind.A))
   word.B=unlist(lapply(c(1:(NM*noF)), word.sum, ind.B))



   Q.2nd = (
	b.word( c(0,1) ) * del.mat[3,4] +
	b.word( c(3,0) ) * 6 * del.mat[9,4] +
	b.word( c(1,1) ) * (2*del.mat[5,4] +del.mat[6,4])
	+b.word( c(4,0) ) * 6 * del.mat[12,4] +
	b.word( c(2,1) ) * (2*del.mat[10,4] + del.mat[11,4])+
	b.word( c(0,2) ) * 2 * del.mat[8,4]) / (6*del.mat[9,4])
     

 



  QB.2nd = (
	b.word( c(0,1) ) * xi.mat[3,4] +
	b.word( c(3,0) ) * 6 * xi.mat[9,4] +
	b.word( c(1,1) ) * (2*xi.mat[5,4] +xi.mat[6,4])
	+b.word( c(4,0) ) * 6 * xi.mat[12,4] +
	b.word( c(2,1) ) * (2*xi.mat[10,4] + xi.mat[11,4])+
	b.word( c(0,2) ) * 2 * xi.mat[8,4]) / (6*xi.mat[9,4])
     

#cat("=== Design\n" )
print(Design)

#cat("Generalised word count\n")
#cat("(#noF, order , Lin,  Quad :  b_k(i,j))\n")
#ii=0
#for (i in 1:noF) {
#    for (j in 1:(i+1)) {
#      ii=ii+1
#      msg=paste(ind.A[ii], ind.B[ii], resList[[i]][j,1], resList[[i]][j,2], round(resList[[i]][j,3],4), sep="     ")
#  cat(msg,"\n")
#  }
#}

cat(" GMA-aberration", "\n")
for (i in 1:noF){
    msg=paste("A", i, sep=" ", collapse="")
    msg=paste(msg, round( word.A[i],4),  sep=" : ", collapse="  ")
    cat(msg, "\n")
   }
cat(" beta-aberration", "\n")
for (i in 1:(NM*noF)){
     msg=paste("B", i, sep=" ", collapse="")
     msg=paste(msg, round(word.B[i],4), sep=" : ", collapse="  ")
     cat(msg, "\n")
   }

msg = paste("Q second-order", round(Q.2nd,5), sep=" :  ", collapse="")
cat(msg, "\n") 
msg = paste("QB second-order", round(QB.2nd,5), sep=" :  ", collapse="")
cat(msg, "\n") 
  }
 





